models/Contacto.php
<?php
namespace app\models;

use yii\base\Model;
use Yii;

Class Contacto extends Model{
    public $nombre;
    public $email;
    public $telefono;
    public $direccion;
    public $asunto;
    public $fecha;
    public $politicas;
    
    public function attributeLabels(){
        return [
            "nombre" => "Nombre completo",
            "email" => "Correo electrónico",
            "telefono" => "Teléfono",
            "direccion" => "Dirección completa",
            "asunto" => "¿Cuál es tu pregunta?",
            "fecha" => "Fecha Nacimiento",
            "politicas" => "Aceptar política de privacidad"
        ];
    }
    
    public function rules(){
        return[
            [["nombre","email","telefono"],"required"],
            ["email","email"],//campo, tipo de dato
            ["nombre","string","length"=>[1,100]],
            ["politicas",'boolean'],
            //["fecha","date","format"=>'yyyy/mm/dd'],
            ["fecha","string"],
            [["direccion","asunto"],"safe"],
            ["politicas","comprobarpoliticas"],//chequear si has aceptado las politicas
        ];
    }
    /**
     * chequear que hayas aceptado las politicas
     * 
     */
    public function comprobarpoliticas($attribute,$params){
        if($this->$attribute==0){
            $this->addError($attribute,"Es necesario que aceptes las políticas de privacidad");
        }
    }
    
    public function contact()
    {
        if ($this->validate()) {
            Yii::$app->mailer->compose()
                ->setTo(Yii::$app->params['contacto'])
                ->setFrom([Yii::$app->params['senderEmail'] => Yii::$app->params['senderName']])
                ->setReplyTo([$this->email => $this->nombre])
                ->setSubject("contacto")
                ->setTextBody($this->asunto)
                ->send();

            return true;
        }
        return false;
    }

}

models/Productos.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "productos".
 *
 * @property int $id
 * @property string|null $nombre
 * @property string|null $foto
 * @property string|null $descripcion
 * @property float|null $precio
 * @property string|null $categorias
 * @property int|null $oferta
 */
class Productos extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'productos';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id'], 'required'],
            [['id', 'oferta'], 'integer'],
            [['precio'], 'number'],
            [['nombre', 'foto', 'categorias'], 'string', 'max' => 200],
            [['descripcion'], 'string', 'max' => 2000],
            [['id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'nombre' => 'Nombre',
            'foto' => 'Foto',
            'descripcion' => 'Descripcion',
            'precio' => 'Precio',
            'categorias' => 'Categorias',
            'oferta' => 'Oferta',
        ];
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Productos;
use yii\data\ActiveDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    public function actionOfertas() {
       //listView
        $dataProvider=new ActiveDataProvider([
            'query'=>Productos::find()->where(['oferta'=>1]),
        ]);
        
        return $this->render("ofertas",[
            'dataProvider'=>$dataProvider,
        ]);
    }
    
    public function actionProductos() {
        //GridView
        $dataProvider=new ActiveDataProvider([
            'query'=> Productos::find()
        ]);
        return $this->render("productos",[
            'datos'=>$dataProvider,
        ]);
    }
    
    public function actionCategorias() {
        //listView
        $dataProvider=new ActiveDataProvider([
            'query'=>Productos::find()->select("categorias")->distinct()
        ]);
        
        return $this->render("categorias",[
            'dataProvider'=>$dataProvider,
        ]);
    }
    
    public function actionVer($categoria) {
        //listView
        $productos =Productos::find()->where(['categorias'=>$categoria]);
        
        $dataProvider=new ActiveDataProvider([
            'query'=>$productos,
        ]);
                
        return $this->render("ver",[
            'dataProvider'=>$dataProvider,
            'categoria'=>$categoria,
        ]);
    }
    public function actionDonde() {
        return $this->render('donde');
    }
    
    public function actionQuienes() {
        return $this->render('quienes');
    }
    
    public function actionNuestros() {
        return $this->render('nuestros');
    }
    
    public function actionInfo() {
        return $this->render('info');
    }
    
    public function actionContacto(){
    $model = new \app\models\Contacto();//objeto de tipo contacto
    
    if ($model->load(Yii::$app->request->post())) {
        if ($model->contact()) {
            //Hay frameworks que no dejan poner lo de las políticas
            //en el modelo. En ese caso se haría aquí: 
            // $model->addError("politicas","No has aceptado las politicas");
            return $this->render("mostrar");
        }
    }

    return $this->render('contacto', [
        'model' => $model,
    ]);
    }
    
   

}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'encodeLabels'=>false,//para poner texto unido de etiquetas
        'items' => [
            ['label' => '<i class="fas fa-home"></i> Inicio', 'url' => ['/site/index']],
            ['label' => '<i class="fas fa-coins"></i> Ofertas', 'url' => ['/site/ofertas']],
            ['label' => '<i class="fas fa-box-open"></i> Productos', 'url' => ['/site/productos']],
            ['label' => '<i class="fas fa-certificate"></i> Categorías', 'url' => ['/site/categorias']],
            ['label' => '<i class="fas fa-info-circle"></i> Nosotros', 'items' => [
                ['label' => 'Dónde estamos', 'url' => ['/site/donde']],
                ['label' => 'Quiénes somos', 'url' => ['/site/quienes']],
                ['label' => 'Nuestros productos', 'url' => ['/site/nuestros']],
                '<div class="dropdown-divider"></div>',
                ['label' => 'Información', 'url' => ['/site/info']],
            ]],
            ['label' => '<i class="far fa-id-card"></i> Contacto', 'url' => ['/site/contacto']],
            
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">La Jota</p>
        <p class="float-right">Desarrollado por Irma Juez</p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/_categorias.php
<?php
use yii\helpers\Html;
?>

  <ul class="list-group list-group-flush">
    <li class="list-group-item">Categoría: <?= $model->categorias ?></li>
    
    <li class="list-group-item">
        <?= Html::a('Ver productos', 
                ['site/ver', 'categoria' => $model->categorias],
                ['class' => 'btn btn-primary']) ?></li>
  </ul>

views/site/_ofertas.php
<?php
use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-5">
    <?php
    echo Html::img("@web/imgs/$model->foto",[
    "class" =>"card-img-top"
    ]);
    
    ?>
    </div>
    <div class="col-lg-7">
        <h2><?= $model->nombre ?><br></h2>
        <div class="bg-warning rounded p-2">Foto:</div>
        <div class="p-1"><?= $model->foto ?></div>
        <div class="bg-warning rounded p-2">Descripción:</div>
        <div class="p-1"><?= $model->descripcion ?></div>
        <div class="bg-warning rounded p-2">Precio:</div>
        <div class="p-1"><?= $model->precio ?>€</div>
        <div class="bg-warning rounded p-2">Categorías:</div>
        <div class="p-1"><?= $model->categorias ?></div>   
    </div>
    
</div>

views/site/_ver.php
<?php
use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-5">
    <?php
    echo Html::img("@web/imgs/$model->foto",[
    "class" =>"card-img-top"
    ]);
    
    ?>
    </div>
    <div class="col-lg-7">
        <h2><?= $model->nombre ?><br></h2>
        <div class="bg-warning rounded p-2">Foto:</div>
        <div class="p-1"><?= $model->foto ?></div>
        <div class="bg-warning rounded p-2">Descripción:</div>
        <div class="p-1"><?= $model->descripcion ?></div>
        <div class="bg-warning rounded p-2">Precio:</div>
        <div class="p-1"><?= $model->precio ?></div>
           
    </div>
    
</div>

views/site/categorias.php
<?php
use yii\widgets\ListView;


echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView'=>'_categorias',
    'itemOptions'=>[
        'class'=>'col-lg-4'
        ],
    'options'=>[
        'class'=>'row'
        ],
    'layout'=>"{items}"
]);

views/site/donde.php
<h1>Dónde estamos</h1>
<iframe src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d5791.867799247307!2d-3.8150442110272964!3d43.461977164921635!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0xd4949ae8a6bee71%3A0xd27cdc801682ba96!2sSantander%2C%20Cantabria!5e0!3m2!1ses!2ses!4v1633948205235!5m2!1ses!2ses" width="600" height="450" style="border:0;" allowfullscreen="" loading="lazy"></iframe>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = 'La Jota';
?>
<div class="site-index">
  
    <div class="body-content">

        <div class="row">
            <div class="col-lg-8">
                <h2 class="mt-3">Productos La Jota</h2>

                <p> Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.
                    Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>

                
            </div>
            
        </div>

    </div>
</div>

views/site/info.php
<h1>Información</h1>
<div class="col-lg-8 text-justify">
    <p> Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
    fugiat nulla pariatur.
    Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
    fugiat nulla pariatur.</p>

views/site/mostrar.php
Muchas gracias, en breve nos pondremos en contacto con usted

views/site/nuestros.php
<h1>Nuestros productos</h1>

<?php
use yii\bootstrap4\Carousel;

echo Carousel::widget([
    'items' => [
        // the item contains only the image
        '<img src="https://picsum.photos/800/800?random=1"/>',
        // equivalent to the above
        ['content' => '<img src="https://picsum.photos/800/800?random=2"/>'],
        // the item contains both the image and the caption
        [
            'content' => '<img src="https://picsum.photos/800/800?random=3"/>',
            'caption' => '<h4>This is title</h4><p>This is the caption text</p>',
            
        ],
    ],
    'options'=>[
        'class'=>'mx-auto col-lg-8n'
    ],
    'controls'=>["patras","palante"]
]);

views/site/ofertas.php
<?php
use yii\widgets\ListView;
?>
<h1 class="list-group-item">Productos en oferta:</h1>
<?php
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView'=>'_ofertas',
    'itemOptions' => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    'options' => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);

views/site/productos.php
<?php
use yii\grid\GridView;
use yii\helpers\Html;

echo GridView::widget([
    'dataProvider' => $datos,
    'columns'=>[
        'id',
        'nombre',
        [
            'label'=>'foto',
            'format'=>'raw',
            'value' => function($data){
                $url='@web/imgs/' . $data->foto;
                return Html::img($url,[
                    'class'=>'img-fluid',
                    'style'=>'width:200px'
                ]);
            }
        ],
        'descripcion',
        'precio',
        'oferta',
        ],
    ]);

views/site/quienes.php
<h1>Quiénes somos</h1>
<div class="col-lg-8 text-justify">
    <p> Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
    fugiat nulla pariatur.
    Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
    fugiat nulla pariatur.</p>

views/site/ver.php
<?php
use yii\widgets\ListView;
?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Listado de productos de categoría <?= $categoria ?></h1>
<?php
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_ver",
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);